//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make RTCReadWritex.ino File  2020/02/25 22:21 //
////////////////////////////////////////////////////
// device_list //
 // X0037 	X0038 	X0039 	// XDevice = 3
 // // YDevice = 0 
 // // MDevice = 0  
 // D0000 	D0001 	D0002 	D0003 	D0004 	D0005 	// DDevice = 6  
 // // TDevice = 0  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // jDevice = 0 
//// device_list //

#include  <M5Stack.h>
#include <Wire.h>
#include <SPI.h>
SPISettings s1(10000000, MSBFIRST, SPI_MODE0);  // MCP23S08 10MHz , MSBFirst, POL:LOW, PHA:UP
SPIClass * vspi = NULL;

#include "RTCReadWritex.h";

HardwareSerial mySerial1(1);  // 連枝のデバッグ用シリアルポート


// マイコンが起動するときに１度だけ呼び出される関数です。
// 主に初期化処理やデバイスの初期化のプログラムをユーザー側で作成します。
void setup(){
	 byte		tmp;

	 // M5Stackを使用する前の初期化関数の呼び出し
	 M5.begin();
	 dacWrite(25,0); // Speakerの出力を消す
	 
	 // プログラム書込みのシリアルポートを使用する場合は、以下の行のコメントを削除してください。
	 // Serial.begin(115200);
	 // Serial.println("setup start");


	 vspi = new SPIClass(VSPI);
	 vspi->begin();
   mySerial1.begin(19200,SERIAL_8N1,17,16);  // パソコン側のシリアル(オンボードデバッグ用)
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 
	 input_refresh();		// 入力更新処理
	 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	  M5.Lcd.init();	// TFTの初期化関数の呼び出し
	  tftInit();
	 // Serial.println("setup end");
}


// Ａｒｄｕｉｎｏがプログラムの実行時、繰り返し呼び出す関数です。
// loop関数の処理が終わるとＡｒｄｕｉｎｏの必要な処理を行います。
// その処理が終われば、再度Ａｒｄｕｉｎｏがloop関数を呼び出します。
////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

  static uint16_t dataLength;
  static uint8_t stxFlag=0;   

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 input_refresh();		// 入力更新処理
	 mcp_refresh();		// MCP更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// 行コメントの表示関数  
// RTC書込み
 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D9030 = 0x20 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D9031 = 0x2 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D9032 = 0x23 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D9033 = 0x23 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D9034 = 0x59 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D9035 = 0x50 ; 
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_E_ON(M9022,9022);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_E_OFF(M9022,9022);
	 }
	 
// 行コメントの表示関数  
// RTC読出し
 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_E_ON(M9021,9021);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_E_OFF(M9021,9021);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9036,9036);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0005 = D9030 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0004 = D9031 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0003 = D9032 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0002 = D9033 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0001 = D9034 ; 
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0000 = D9035 ; 
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0037,37);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ < D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 < 5);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// INCB Binaryデータのインクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0000, 0)) { 
	 	 	 D9005++; 
	 	 	 SET_UTRG_ON(UTRG0000,0);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0000,0);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ > D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 > 0);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// DECB Binaryデータのデクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0001, 1)) { 
	 	 	 D9005--; 
	 	 	 SET_UTRG_ON(UTRG0001,1);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0001,1);
	 } 
// END 
//	 M5.update(); 
	// Serial.println();
	 SET_E_OFF(M9038,0);

 if (mySerial1.available()) {
    while(mySerial1.available()){
      int inByte = mySerial1.read();
			if ((stxFlag & 0x01) == 0) {  //  stx受信フラグがあるかどうかのチェック 0なし、1あり		
				if (inByte == 0x02) { //  １回目のＳＴＸ受信時		
					stxFlag = 1;    // STX受信フラグのセット		
					rvData[inposrc++] = (uint8_t)inByte;  // 受信データを格納		
				}		
				else {		
					inposrc = 0;		
					stxFlag = 0;		
				}		
			}		
			else {  // データサイズ受信フラグ判定		
				if ((stxFlag & 0x02) == 0) {  //  // データ長受信フラグがあるか判定 　0なし、2あり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					dataLength = (uint8_t)inByte & 0x7F;  // データサイズをセット		
					stxFlag |= 0x02;    // データ長受信フラグありに変更		
				}		
				else {  // データサイズ受信フラグあり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					if (dataLength < (inposrc - 4)) { // 受信データの位置が受信予定サイズより大きくなったら		
						inposrc = 0;            // 位置をクリアする		
						stxFlag = 0;            // 受信フラグをクリア		
					}		
					else if ((inposrc - 4) < dataLength) { // dataLengthより短い場合、データがそろっていない		
					}		
					else if (rvData[inposrc - 1] == 0x03) { // 終端文字ＥＴＸを受信したとき		
						int ressize;		
						ressize = AnalyzePacket(rvData, inposrc);		// 連枝からのモニタ要求に対する応答のデータ生成とデータ作成
						if (ressize>0) {		
							for (int sendcount = 0; sendcount < ressize; sendcount++) {		
								mySerial1.write(txData[sendcount]);		
							}		
						}		
						inposrc = 0;  // 位置をクリアする		
						stxFlag = 0;  //受信フラグをクリア		
					}		
					else {		
						// 受信予定サイズだけど、ETXじゃない場合   		
					}		
				}		
			}		
		}		
	}		


	
}
////////////////////////////// Loop 終了 //////////////////////////////
