//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make kakuspii2c.ino File  2020/02/13 15:19 //
////////////////////////////////////////////////////
// device_list //
 // // XDevice = 0
 // Y0026 	// YDevice = 1 
 // // MDevice = 0  
 // D0024 	D0026 	D0027 	D0028 	D0029 	// DDevice = 5  
 // // TDevice = 0  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // jDevice = 0 
//// device_list //

#include  <M5Stack.h>
#include <Wire.h>
#include <SPI.h>
SPISettings s1(10000000, MSBFIRST, SPI_MODE0);  // MCP23S08 10MHz , MSBFirst, POL:LOW, PHA:UP
SPIClass * vspi = NULL;

short spich = -1;

#include "kakuspii2c.h";
// 0,0,79



// マイコンが起動するときに１度だけ呼び出される関数です。
// 主に初期化処理やデバイスの初期化のプログラムをユーザー側で作成します。
void setup(){
	 byte		tmp;

	 // M5Stackを使用する前の初期化関数の呼び出し
	 M5.begin();
	 dacWrite(25,0); // Speakerの出力を消す
	 
	 // プログラム書込みのシリアルポートを使用する場合は、以下の行のコメントを削除してください。
	 // Serial.begin(115200);
	 // Serial.println("setup start");


	 vspi = new SPIClass(VSPI);
	 vspi->begin();
// デバッグ用のシリアル通信出力 
	 Serial.begin(115200);	// 通信速度：115200bps,データ長8bit,ストップビット1bit,パリティなし
	 for (byte i=0; i<sizeof(out_no); i++) {
	 	 pinMode(out_no[i],OUTPUT);
	 } 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	 initMCP(7, (unsigned short)MCP_CH7_TRIS);	// CH7 MCP23017初期化処理
	 initTFT(0x3E);

	 // Serial.println("setup end");
}


// Ａｒｄｕｉｎｏがプログラムの実行時、繰り返し呼び出す関数です。
// loop関数の処理が終わるとＡｒｄｕｉｎｏの必要な処理を行います。
// その処理が終われば、再度Ａｒｄｕｉｎｏがloop関数を呼び出します。
////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 output_refresh();	// 出力更新処理
	 mcp_refresh();		// MCP更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
//00009001 2000234E 00000000 00000001 00000000 00000000
// // // LD b0 D0 B1 P0 F0 L0 BIN0 M9038 0 0 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9038,9038);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000000 00000000 00000000 00100000
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 0 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//0000807B 00000000 00000000 00000000 00000000 00B00000
// // STATS b0 D0 B0 P0 F0 L0 BIN0 11 0 
 // STATS 
// STATS(7B) 
	 if (aax & iix) { 

	 	 vspi->beginTransaction(s1);
	 	 spich=-1;

	 } 
//02308079 00000008 00000046 12000026 00000000 00B00001
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 1 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x46 & 0xff);

	 } 
//02308079 00000008 00000000 12000026 00000000 00B00002
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0000 Y0026 11 2 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x0 & 0xff);

	 } 
//02308079 00000008 00000044 12000026 00000000 00B00003
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 3 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x44 & 0xff);

	 } 
//0000800E 00000000 00000000 00000000 00000000 00100000
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 0 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0000807C 00000000 00000000 00000000 00000000 00B00004
// // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 4 
 // STOPS 
// STOPS(7C) 
	 if (aax & iix) { 

	 	 digitalWrite(spich,HIGH);
	 	 spich=-1;
	 	 vspi->endTransaction(); 

	 } 
//00009001 2000234E 00000000 00000001 00000000 00000005
// // // LD b0 D0 B1 P0 F0 L0 BIN0 M9038 0 5 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9038,9038);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000001 00000000 00000000 00100005
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 5 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//0000807B 00000000 00000000 00000000 00000000 00B00005
// // STATS b0 D0 B0 P0 F0 L0 BIN0 11 5 
 // STATS 
// STATS(7B) 
	 if (aax & iix) { 

	 	 vspi->beginTransaction(s1);
	 	 spich=-1;

	 } 
//02308079 00000008 00000046 12000026 00000000 00B00006
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 6 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x46 & 0xff);

	 } 
//02308079 00000008 00000006 12000026 00000000 00B00007
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0006 Y0026 11 7 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x6 & 0xff);

	 } 
//02308079 00000008 00000044 12000026 00000000 00B00008
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 8 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x44 & 0xff);

	 } 
//0000800E 00000000 00000001 00000000 00000000 00100005
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 5 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0000807C 00000000 00000000 00000000 00000000 00B00009
// // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 9 
 // STOPS 
// STOPS(7C) 
	 if (aax & iix) { 

	 	 digitalWrite(spich,HIGH);
	 	 spich=-1;
	 	 vspi->endTransaction(); 

	 } 
//00009001 2000234E 00000000 00000001 00000000 0000000A
// // // LD b0 D0 B1 P0 F0 L0 BIN0 M9038 0 10 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9038,9038);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000002 00000000 00000000 0010000A
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//0000807B 00000000 00000000 00000000 00000000 00B0000A
// // STATS b0 D0 B0 P0 F0 L0 BIN0 11 10 
 // STATS 
// STATS(7B) 
	 if (aax & iix) { 

	 	 vspi->beginTransaction(s1);
	 	 spich=-1;

	 } 
//02308079 00000008 00000046 12000026 00000000 00B0000B
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 11 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x46 & 0xff);

	 } 
//02308079 00000008 00000009 12000026 00000000 00B0000C
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0009 Y0026 11 12 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x9 & 0xff);

	 } 
//02308079 00000008 00000044 12000026 00000000 00B0000D
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 13 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x44 & 0xff);

	 } 
//02308079 00000008 00000044 12000026 00000000 00B0000E
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 14 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x44 & 0xff);

	 } 
//0000800E 00000000 00000002 00000000 00000000 0010000A
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0000807C 00000000 00000000 00000000 00000000 00B0000F
// // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 15 
 // STOPS 
// STOPS(7C) 
	 if (aax & iix) { 

	 	 digitalWrite(spich,HIGH);
	 	 spich=-1;
	 	 vspi->endTransaction(); 

	 } 
//00009001 00000170 00000000 00000001 00000000 00000010
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 16 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//00008005 10000177 00000000 00000001 00000000 00000011
// // // OR b0 D0 B0 P0 F0 L0 BIN0 Y0177 0 17 
 // OR 
// OR(05) 
	 flag = GET_MCPX(Y0177,0x177);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//00008004 0000017F 00000000 00000002 00000000 00100010
// // // ANI b0 D0 B0 P0 F0 L0 BIN0 X017F 1 16 
 // ANI 
// ANI(04) 
	 flag = GET_MCPX(X017F,0x17F);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
//0000800F 10000177 00000000 00000007 00000000 00B00010
// // // OUTR b0 D0 B0 P0 F0 L0 BIN0 Y0177 11 16 
 // OUT 
// OUTR(0F) 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_MCPY_ON(Y0177,0x177);
	 } else { 
	 	 SET_MCPY_OFF(Y0177,0x177);
	 	 // 条件が不成立時マイスキャン実行されます。
	 }
	 
//00009001 0000017F 00000000 00000001 00000000 00000012
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X017F 0 18 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X017F,0x17F);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//00008005 10000178 00000000 00000001 00000000 00000013
// // // OR b0 D0 B0 P0 F0 L0 BIN0 Y0178 0 19 
 // OR 
// OR(05) 
	 flag = GET_MCPX(Y0178,0x178);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//00008004 00000170 00000000 00000002 00000000 00100012
// // // ANI b0 D0 B0 P0 F0 L0 BIN0 X0170 1 18 
 // ANI 
// ANI(04) 
	 flag = GET_MCPX(X0170,0x170);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
//0000800F 10000178 00000000 00000007 00000000 00B00012
// // // OUTR b0 D0 B0 P0 F0 L0 BIN0 Y0178 11 18 
 // OUT 
// OUTR(0F) 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_MCPY_ON(Y0178,0x178);
	 } else { 
	 	 SET_MCPY_OFF(Y0178,0x178);
	 	 // 条件が不成立時マイスキャン実行されます。
	 }
	 
//00009002 00000170 00000000 00000002 00000000 00000014
// // // LDI b0 D0 B1 P0 F0 L0 BIN0 X0170 0 20 
 // LDI 
// LDI(02) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000003 00000000 00000000 00100014
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 20 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//0000807B 00000000 00000000 00000000 00000000 00B00014
// // STATS b0 D0 B0 P0 F0 L0 BIN0 11 20 
 // STATS 
// STATS(7B) 
	 if (aax & iix) { 

	 	 vspi->beginTransaction(s1);
	 	 spich=-1;

	 } 
//02308079 00000008 00000046 12000026 00000000 00B00015
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 21 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x46 & 0xff);

	 } 
//02308079 00000008 00000009 12000026 00000000 00B00016
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0009 Y0026 11 22 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x9 & 0xff);

	 } 
//02308079 00000008 00000045 12000026 00000000 00B00017
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0045 Y0026 11 23 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x45 & 0xff);

	 } 
//02308079 00000008 00000045 12000026 00000000 00B00018
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0045 Y0026 11 24 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x45 & 0xff);

	 } 
//0000800E 00000000 00000003 00000000 00000000 00100014
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 20 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0000807C 00000000 00000000 00000000 00000000 00B00019
// // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 25 
 // STOPS 
// STOPS(7C) 
	 if (aax & iix) { 

	 	 digitalWrite(spich,HIGH);
	 	 spich=-1;
	 	 vspi->endTransaction(); 

	 } 
//00009001 00000170 00000000 00000001 00000000 0000001A
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 26 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000004 00000000 00000000 0010001A
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 26 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//0000807B 00000000 00000000 00000000 00000000 00B0001A
// // STATS b0 D0 B0 P0 F0 L0 BIN0 11 26 
 // STATS 
// STATS(7B) 
	 if (aax & iix) { 

	 	 vspi->beginTransaction(s1);
	 	 spich=-1;

	 } 
//02308079 00000008 00000046 12000026 00000000 00B0001B
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 27 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x46 & 0xff);

	 } 
//02308079 00000008 00000009 12000026 00000000 00B0001C
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0009 Y0026 11 28 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x9 & 0xff);

	 } 
//02308079 00000008 00000046 12000026 00000000 00B0001D
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 29 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x46 & 0xff);

	 } 
//02308079 00000008 00000046 12000026 00000000 00B0001E
// // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 30 
 // WSPD0 
// WSPD0(79) 
	 if (aax & iix) { 

	 	 if(spich==-1) { 
	 	 	 spich=26;
	 	 	 digitalWrite(spich, LOW);
	 	 }
	 	 vspi->transfer(0x46 & 0xff);

	 } 
//0000800E 00000000 00000004 00000000 00000000 0010001A
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 26 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0000807C 00000000 00000000 00000000 00000000 00B0001F
// // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 31 
 // STOPS 
// STOPS(7C) 
	 if (aax & iix) { 

	 	 digitalWrite(spich,HIGH);
	 	 spich=-1;
	 	 vspi->endTransaction(); 

	 } 
//00009001 00000170 00000000 00000001 00000000 00000020
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 32 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000005 00000000 00000000 00100020
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 32 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//01108051 00009876 D0000018 00000000 00000000 00B00020
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H9876 D0024 11 32 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0024 = 0x9876 ; 
	 } 
//0000805B D0000018 D000001A 00000000 00000000 00B00021
// // // // BCDDA b0 D0 B0 P0 F0 L0 BIN0 D0024 D0026 11 33 
 // BCDDA 
// BCDDA(5B) 
	 if (aax & iix) { 
	 	 	 unsigned short tmpData = D0024;  
	 	 	 unsigned short S2 = ((tmpData & 0x00f0) >> 4 | 0x30) | (((tmpData & 0x000f)<<8) | 0x3000) ;
	 	 	 unsigned short S1 = ((tmpData & 0x0f00) | 0x3000) | ((tmpData & 0xf000) >> 12 | 0x30) ;
	 	 	 short* p = &D0026; 
	 	 	 *p = (short)S1;
	 	 	 p++;
	 	 	 *p = S2; 
	 } 

//00008051 D000001A D000001C 00000000 00000000 00B00022
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0026 D0028 11 34 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0028 = D0026 ; 
	 } 
//00008051 D000001B D000001D 00000000 00000000 00B00023
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0027 D0029 11 35 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0029 = D0027 ; 
	 } 
//0000800E 00000000 00000005 00000000 00000000 00100020
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 32 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0020805C D000001C 00000002 00000000 00000000 00B00024
// // // // SUP0 b0 D0 B0 P0 F0 L2 BIN0 D0028 K0002 11 36 
 // SUP0 
// SUP0(5C) 
	 if (aax & iix) { 
	 	 short *p = &D0028;
	 	 for(int i=0; i<2; i++)
	 	 {
	 	 	 if((*p&0xff)==0x30) {
	 	 	 	 *p=*p & 0xFFEF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 if((*p&0xff00)==0x3000) {
	 	 	 	 *p=*p & 0xEFFF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 p++;
	 	 }
	 } 

//00009001 00000170 00000000 00000001 00000000 00000025
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 37 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000006 00000000 00000000 00100025
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 37 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//0010804A 00000004 D000001A 1200002C 00000000 00B00025
// // // // // LCDH b0 D0 B0 P0 F0 L1 BIN0 K0004 D0026 Y002C 11 37 
 // LCDH 
// まだ未対応です。
// LCDH(4A) 
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0026;
	 	 InstSet(0x3E,0x80);  // 1行目出力 
	 	 for(int i=0; i<4; i++){
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
//0000800E 00000000 00000006 00000000 00000000 00100025
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 37 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0010804B 00000004 D000001C 1200002C 00000000 00B00026
// // // // // LCDL b0 D0 B0 P0 F0 L1 BIN0 K0004 D0028 Y002C 11 38 
 // LCDL 
// まだ未対応です。
// LCDL(4B) 
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0028;
	 	 InstSet(0x3E,0x80 | 0x40); // 2行目出力
	 	 for(int i=0; i<4; i++){ 
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
//00009002 00000170 00000000 00000002 00000000 00000027
// // // LDI b0 D0 B1 P0 F0 L0 BIN0 X0170 0 39 
 // LDI 
// LDI(02) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000007 00000000 00000000 00100027
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 39 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//01108051 00001234 D0000018 00000000 00000000 00B00027
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H1234 D0024 11 39 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0024 = 0x1234 ; 
	 } 
//0000805B D0000018 D000001A 00000000 00000000 00B00028
// // // // BCDDA b0 D0 B0 P0 F0 L0 BIN0 D0024 D0026 11 40 
 // BCDDA 
// BCDDA(5B) 
	 if (aax & iix) { 
	 	 	 unsigned short tmpData = D0024;  
	 	 	 unsigned short S2 = ((tmpData & 0x00f0) >> 4 | 0x30) | (((tmpData & 0x000f)<<8) | 0x3000) ;
	 	 	 unsigned short S1 = ((tmpData & 0x0f00) | 0x3000) | ((tmpData & 0xf000) >> 12 | 0x30) ;
	 	 	 short* p = &D0026; 
	 	 	 *p = (short)S1;
	 	 	 p++;
	 	 	 *p = S2; 
	 } 

//00008051 D000001A D000001C 00000000 00000000 00B00029
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0026 D0028 11 41 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0028 = D0026 ; 
	 } 
//00008051 D000001B D000001D 00000000 00000000 00B0002A
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0027 D0029 11 42 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0029 = D0027 ; 
	 } 
//0000800E 00000000 00000007 00000000 00000000 00100027
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 39 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0020805C D000001C 00000002 00000000 00000000 00B0002B
// // // // SUP0 b0 D0 B0 P0 F0 L2 BIN0 D0028 K0002 11 43 
 // SUP0 
// SUP0(5C) 
	 if (aax & iix) { 
	 	 short *p = &D0028;
	 	 for(int i=0; i<2; i++)
	 	 {
	 	 	 if((*p&0xff)==0x30) {
	 	 	 	 *p=*p & 0xFFEF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 if((*p&0xff00)==0x3000) {
	 	 	 	 *p=*p & 0xEFFF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 p++;
	 	 }
	 } 

//00009002 00000170 00000000 00000002 00000000 0000002C
// // // LDI b0 D0 B1 P0 F0 L0 BIN0 X0170 0 44 
 // LDI 
// LDI(02) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000008 00000000 00000000 0010002C
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 44 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//0010804A 00000004 D000001A 1200002C 00000000 00B0002C
// // // // // LCDH b0 D0 B0 P0 F0 L1 BIN0 K0004 D0026 Y002C 11 44 
 // LCDH 
// まだ未対応です。
// LCDH(4A) 
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0026;
	 	 InstSet(0x3E,0x80);  // 1行目出力 
	 	 for(int i=0; i<4; i++){
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
//0000800E 00000000 00000008 00000000 00000000 0010002C
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 44 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0010804B 00000004 D000001C 1200002C 00000000 00B0002D
// // // // // LCDL b0 D0 B0 P0 F0 L1 BIN0 K0004 D0028 Y002C 11 45 
 // LCDL 
// まだ未対応です。
// LCDL(4B) 
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0028;
	 	 InstSet(0x3E,0x80 | 0x40); // 2行目出力
	 	 for(int i=0; i<4; i++){ 
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
//00009001 20001F40 00000000 00000001 00000000 0000002E
// // // LD b0 D0 B1 P0 F0 L0 BIN0 M8000 0 46 
 //0000800F 20001F45 00000000 00000007 00000000 00B0002E
// // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8005 11 46 
 //00009010 00000000 00000000 00000000 00000000 00B0002F
// // END b0 D0 B1 P0 F0 L0 BIN0 11 47 
 // END 
// END(10) 
	 output_refresh();	// 出力更新処理
//	 M5.update(); 
	// Serial.println();
	 SET_E_OFF(M9038,0);

	
}
////////////////////////////// Loop 終了 //////////////////////////////
