//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make kakuspii2cx.ino File  2020/02/25 20:16 //
////////////////////////////////////////////////////
// device_list //
 // // XDevice = 0
 // Y0026 	// YDevice = 1 
 // // MDevice = 0  
 // D0000 	D0024 	D0026 	D0027 	D0028 	D0029 	// DDevice = 6  
 // // TDevice = 0  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // jDevice = 0 
//// device_list //

#include  <M5Stack.h>
#include <Wire.h>
#include <SPI.h>
SPISettings s1(10000000, MSBFIRST, SPI_MODE0);  // MCP23S08 10MHz , MSBFirst, POL:LOW, PHA:UP
SPIClass * vspi = NULL;

#include "kakuspii2cx.h";

HardwareSerial mySerial1(1);  // 連枝のデバッグ用シリアルポート


// マイコンが起動するときに１度だけ呼び出される関数です。
// 主に初期化処理やデバイスの初期化のプログラムをユーザー側で作成します。
void setup(){
	 byte		tmp;

	 // M5Stackを使用する前の初期化関数の呼び出し
	 M5.begin();
	 dacWrite(25,0); // Speakerの出力を消す
	 
	 // プログラム書込みのシリアルポートを使用する場合は、以下の行のコメントを削除してください。
	 // Serial.begin(115200);
	 // Serial.println("setup start");


	 vspi = new SPIClass(VSPI);
	 vspi->begin();
   mySerial1.begin(19200,SERIAL_8N1,17,16);  // パソコン側のシリアル(オンボードデバッグ用)
	 for (byte i=0; i<sizeof(out_no); i++) {
	 	 pinMode(out_no[i],OUTPUT);
	 } 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	  M5.Lcd.init();	// TFTの初期化関数の呼び出し
	  tftInit();
	 initMCP(7, (unsigned short)MCP_CH7_TRIS);	// CH7 MCP23017初期化処理
	 initTFT(0x3E);

	 // Serial.println("setup end");
}


// Ａｒｄｕｉｎｏがプログラムの実行時、繰り返し呼び出す関数です。
// loop関数の処理が終わるとＡｒｄｕｉｎｏの必要な処理を行います。
// その処理が終われば、再度Ａｒｄｕｉｎｏがloop関数を呼び出します。
////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

  static uint16_t dataLength;
  static uint8_t stxFlag=0;   

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 output_refresh();	// 出力更新処理
	 mcp_refresh();		// MCP更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9038,9038);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// STATS 
	 if (aax & iix) { 

	 	 	 vspi->beginTransaction(s1);
	 	 	 digitalWrite(26, LOW);

	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0000 = 0x100 ; 
	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x46 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x0 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x44 & 0xff);

	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// STOPS 
	 if (aax & iix) { 

	 	 	 digitalWrite(26, HIGH);
	 	 	 vspi->endTransaction(); 

	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9038,9038);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// STATS 
	 if (aax & iix) { 

	 	 	 vspi->beginTransaction(s1);
	 	 	 digitalWrite(26, LOW);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x46 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x6 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x44 & 0xff);

	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// STOPS 
	 if (aax & iix) { 

	 	 	 digitalWrite(26, HIGH);
	 	 	 vspi->endTransaction(); 

	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9038,9038);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// STATS 
	 if (aax & iix) { 

	 	 	 vspi->beginTransaction(s1);
	 	 	 digitalWrite(26, LOW);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x46 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x9 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x44 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x44 & 0xff);

	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// STOPS 
	 if (aax & iix) { 

	 	 	 digitalWrite(26, HIGH);
	 	 	 vspi->endTransaction(); 

	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OR 
	 flag = GET_MCPX(Y0177,0x177);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI 
	 flag = GET_MCPX(X017F,0x17F);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_MCPY_ON(Y0177,0x177);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_MCPY_OFF(Y0177,0x177);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X017F,0x17F);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OR 
	 flag = GET_MCPX(Y0178,0x178);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI 
	 flag = GET_MCPX(X0170,0x170);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_MCPY_ON(Y0178,0x178);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_MCPY_OFF(Y0178,0x178);
	 }
	 
// LDI 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// STATS 
	 if (aax & iix) { 

	 	 	 vspi->beginTransaction(s1);
	 	 	 digitalWrite(26, LOW);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x46 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x9 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x45 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x45 & 0xff);

	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// STOPS 
	 if (aax & iix) { 

	 	 	 digitalWrite(26, HIGH);
	 	 	 vspi->endTransaction(); 

	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// STATS 
	 if (aax & iix) { 

	 	 	 vspi->beginTransaction(s1);
	 	 	 digitalWrite(26, LOW);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x46 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x9 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x46 & 0xff);

	 } 
// WSPD0 
	 if (aax & iix) { 

	 	 vspi->transfer(0x46 & 0xff);

	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// STOPS 
	 if (aax & iix) { 

	 	 	 digitalWrite(26, HIGH);
	 	 	 vspi->endTransaction(); 

	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0024 = 0x9876 ; 
	 } 
// BCDDA 
	 if (aax & iix) { 
	 	 	 unsigned short tmpData = D0024;  
	 	 	 unsigned short S2 = ((tmpData & 0x00f0) >> 4 | 0x30) | (((tmpData & 0x000f)<<8) | 0x3000) ;
	 	 	 unsigned short S1 = ((tmpData & 0x0f00) | 0x3000) | ((tmpData & 0xf000) >> 12 | 0x30) ;
	 	 	 short* p = &D0026; 
	 	 	 *p = (short)S1;
	 	 	 p++;
	 	 	 *p = S2; 
	 } 

// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0028 = D0026 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0029 = D0027 ; 
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// SUP0 
	 if (aax & iix) { 
	 	 short *p = &D0028;
	 	 for(int i=0; i<2; i++)
	 	 {
	 	 	 if((*p&0xff)==0x30) {
	 	 	 	 *p=*p & 0xFFEF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 if((*p&0xff00)==0x3000) {
	 	 	 	 *p=*p & 0xEFFF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 p++;
	 	 }
	 } 

// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// LCDH 
// まだ未対応です。
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0026;
	 	 InstSet(0x3E,0x80);  // 1行目出力 
	 	 for(int i=0; i<4; i++){
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// LCDL 
// まだ未対応です。
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0028;
	 	 InstSet(0x3E,0x80 | 0x40); // 2行目出力
	 	 for(int i=0; i<4; i++){ 
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
// LDI 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0024 = 0x1234 ; 
	 } 
// BCDDA 
	 if (aax & iix) { 
	 	 	 unsigned short tmpData = D0024;  
	 	 	 unsigned short S2 = ((tmpData & 0x00f0) >> 4 | 0x30) | (((tmpData & 0x000f)<<8) | 0x3000) ;
	 	 	 unsigned short S1 = ((tmpData & 0x0f00) | 0x3000) | ((tmpData & 0xf000) >> 12 | 0x30) ;
	 	 	 short* p = &D0026; 
	 	 	 *p = (short)S1;
	 	 	 p++;
	 	 	 *p = S2; 
	 } 

// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0028 = D0026 ; 
	 } 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0029 = D0027 ; 
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// SUP0 
	 if (aax & iix) { 
	 	 short *p = &D0028;
	 	 for(int i=0; i<2; i++)
	 	 {
	 	 	 if((*p&0xff)==0x30) {
	 	 	 	 *p=*p & 0xFFEF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 if((*p&0xff00)==0x3000) {
	 	 	 	 *p=*p & 0xEFFF;
	 	 	 } else {
	 	 	 	 break;
	 	 	 }
	 	 	 p++;
	 	 }
	 } 

// LDI 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_MCPX(X0170,0x170);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// LCDH 
// まだ未対応です。
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0026;
	 	 InstSet(0x3E,0x80);  // 1行目出力 
	 	 for(int i=0; i<4; i++){
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// LCDL 
// まだ未対応です。
	 if (aax & iix) { 
	 	 char* ppos = (char*)&D0028;
	 	 InstSet(0x3E,0x80 | 0x40); // 2行目出力
	 	 for(int i=0; i<4; i++){ 
	 	   WriteChar(0x3E,*ppos);
	 	   ppos++;
	 	 }
	 } 
// END 
	 output_refresh();	// 出力更新処理
//	 M5.update(); 
	// Serial.println();
	 SET_E_OFF(M9038,0);

 if (mySerial1.available()) {
    while(mySerial1.available()){
      int inByte = mySerial1.read();
			if ((stxFlag & 0x01) == 0) {  //  stx受信フラグがあるかどうかのチェック 0なし、1あり		
				if (inByte == 0x02) { //  １回目のＳＴＸ受信時		
					stxFlag = 1;    // STX受信フラグのセット		
					rvData[inposrc++] = (uint8_t)inByte;  // 受信データを格納		
				}		
				else {		
					inposrc = 0;		
					stxFlag = 0;		
				}		
			}		
			else {  // データサイズ受信フラグ判定		
				if ((stxFlag & 0x02) == 0) {  //  // データ長受信フラグがあるか判定 　0なし、2あり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					dataLength = (uint8_t)inByte & 0x7F;  // データサイズをセット		
					stxFlag |= 0x02;    // データ長受信フラグありに変更		
				}		
				else {  // データサイズ受信フラグあり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					if (dataLength < (inposrc - 4)) { // 受信データの位置が受信予定サイズより大きくなったら		
						inposrc = 0;            // 位置をクリアする		
						stxFlag = 0;            // 受信フラグをクリア		
					}		
					else if ((inposrc - 4) < dataLength) { // dataLengthより短い場合、データがそろっていない		
					}		
					else if (rvData[inposrc - 1] == 0x03) { // 終端文字ＥＴＸを受信したとき		
						int ressize;		
						ressize = AnalyzePacket(rvData, inposrc);		// 連枝からのモニタ要求に対する応答のデータ生成とデータ作成
						if (ressize>0) {		
							for (int sendcount = 0; sendcount < ressize; sendcount++) {		
								mySerial1.write(txData[sendcount]);		
							}		
						}		
						inposrc = 0;  // 位置をクリアする		
						stxFlag = 0;  //受信フラグをクリア		
					}		
					else {		
						// 受信予定サイズだけど、ETXじゃない場合   		
					}		
				}		
			}		
		}		
	}		


	
}
////////////////////////////// Loop 終了 //////////////////////////////
