//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make tft_cur_outx.ino File  2020/02/26 19:06 //
////////////////////////////////////////////////////
// device_list //
 // X0000 	X0037 	X0038 	X0039 	// XDevice = 4
 // Y0005 	Y0025 	Y0026 	// YDevice = 3 
 // M0000 	M0001 	// MDevice = 2  
 // D0000 	D0001 	D0002 	// DDevice = 3  
 // T0000 	T0001 	T0002 	T0200 	T0201 	// TDevice = 5  
 // C0000 	C0001 	C0002 	// CDevice = 3  
 // // LDevice = 0  
 // // rDevice = 0  
 // // jDevice = 0 
//// device_list //

#include  <M5Stack.h>
#include <Wire.h>
#include "tft_cur_outx.h";
 // ;IEND_ST
// // タイマー割込み時の処理を行うタスク（１ｍｓ単位で呼び出される）
void InterruptFunction(void *args) { 
	 delay(1); 

	 while(1) {
	 	 if(xSemaphoreTake(timerSemaphore,0) == pdTRUE){
	 	 	 portENTER_CRITICAL(&timerMux);
	 	 	 
	 	 	 if (offCounter<=0){
	 	 	 	 onCounter = 1;
	 	 	 	 offCounter = 1;
	 	 	 	 SET_E_ON(M9053, 9053);
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9053,9053);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// DACO 
// -[DACO D0 Y25] 使用できるピンは IO25 と IO26のみです。設定値は0-255までです。
// 安全のため、ＯＦＦ時は出力を０にするようになっています。必要に応じてＯＦＦ部分をコメントアウトしてください。
	 if (aax & iix) { 
	 	 	 dacWrite(25,D0001); 
	 } else {
	 	 	 // ここから先のプログラムは条件ＯＦＦ時に出力を最低値にセットします。不要ならコメントアウトしてください。
	 	 dacWrite(25,0); 
	 }
// IRET Hit 
	 	 	 	 }
	 	 	 if (onCounter<=0){
	 	 	 	 onCounter = 1;
	 	 	 	 offCounter = 1;
	 	 	 	 SET_E_OFF(M9053, 9053);
// LDI 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9053,9053);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// DACO 
// -[DACO D0 Y25] 使用できるピンは IO25 と IO26のみです。設定値は0-255までです。
// 安全のため、ＯＦＦ時は出力を０にするようになっています。必要に応じてＯＦＦ部分をコメントアウトしてください。
	 if (aax & iix) { 
	 	 	 dacWrite(25,0x0); 
	 } else {
	 	 	 // ここから先のプログラムは条件ＯＦＦ時に出力を最低値にセットします。不要ならコメントアウトしてください。
	 	 dacWrite(25,0); 
	 }
// IRET Hit 
// END 
	 	 	 }
	 	 	 portEXIT_CRITICAL(&timerMux);
	 	 }
	 	 vTaskDelay(1); // タスクの切り替えのために呼び出し(1ms待ち)
	 }
}

HardwareSerial mySerial1(1);  // 連枝のデバッグ用シリアルポート


// マイコンが起動するときに１度だけ呼び出される関数です。
// 主に初期化処理やデバイスの初期化のプログラムをユーザー側で作成します。
void setup(){
	 byte		tmp;

	 // M5Stackを使用する前の初期化関数の呼び出し
	 M5.begin();
	 dacWrite(25,0); // Speakerの出力を消す
	 
	 // プログラム書込みのシリアルポートを使用する場合は、以下の行のコメントを削除してください。
	 // Serial.begin(115200);
	 // Serial.println("setup start");


   mySerial1.begin(19200,SERIAL_8N1,17,16);  // パソコン側のシリアル(オンボードデバッグ用)
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 
	 input_refresh();		// 入力更新処理
	 
	 for (byte i=0; i<sizeof(out_no); i++) {
	 	 pinMode(out_no[i],OUTPUT);
	 } 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	  M5.Lcd.init();	// TFTの初期化関数の呼び出し
	  tftInit();
	 	 timerSemaphore = xSemaphoreCreateBinary();
	 	  xTaskCreatePinnedToCore(InterruptFunction, "InterruptFunction", 4096, NULL, 5, NULL,1);
	 // Serial.println("setup end");
}


// Ａｒｄｕｉｎｏがプログラムの実行時、繰り返し呼び出す関数です。
// loop関数の処理が終わるとＡｒｄｕｉｎｏの必要な処理を行います。
// その処理が終われば、再度Ａｒｄｕｉｎｏがloop関数を呼び出します。
////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

  static uint16_t dataLength;
  static uint8_t stxFlag=0;   

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 output_refresh();	// 出力更新処理
	 input_refresh();		// 入力更新処理
	 mcp_refresh();		// MCP更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0037,37);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ < D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 < 5);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// INCB Binaryデータのインクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0000, 0)) { 
	 	 	 D9005++; 
	 	 	 SET_UTRG_ON(UTRG0000,0);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0000,0);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ > D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 > 0);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// DECB Binaryデータのデクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0001, 1)) { 
	 	 	 D9005--; 
	 	 	 SET_UTRG_ON(UTRG0001,1);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0001,1);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ = D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 == 1);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OR 
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI 
	 flag = GET_M(M0001,1);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_M_ON(M0000,0);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_M_OFF(M0000,0);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI 
	 flag = GET_T(T0201,201);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// TIM1M ラダー上( T300 )->Cプログラム( T200 ) 
// 作成するラダーによりタイマーの時間が保証されません。単純な回路なら１ｍｓ単位で動作します。
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0002,2)) { 
	 	 	 SET_UTRG_ON(UTRG0002,2);
	 	 } else { 
	 	 	 if ((t_count[200] + (spantime) ) >=  1 * 1000){
	 	 	 	 t_count[200] = 1 * 1000; 
	 	 	 	 SET_T_ON(T0200,200);
	 	 	 } else {
	 	 	 	 t_count[200] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[200] = 0;
	 	 SET_T_OFF(T0200,200);
	 	 SET_UTRG_OFF(UTRG0002,2);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_T(T0200,200);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// TIM1M ラダー上( T301 )->Cプログラム( T201 ) 
// 作成するラダーによりタイマーの時間が保証されません。単純な回路なら１ｍｓ単位で動作します。
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0003,3)) { 
	 	 	 SET_UTRG_ON(UTRG0003,3);
	 	 } else { 
	 	 	 if ((t_count[201] + (spantime) ) >=  1 * 1000){
	 	 	 	 t_count[201] = 1 * 1000; 
	 	 	 	 SET_T_ON(T0201,201);
	 	 	 } else {
	 	 	 	 t_count[201] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[201] = 0;
	 	 SET_T_OFF(T0201,201);
	 	 SET_UTRG_OFF(UTRG0003,3);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ = D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 == 2);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_M_ON(M0001,1);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_M_OFF(M0001,1);
	 }
	 
// LDI 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0000,0);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
// RST 
	 if (aax & iix) { 
	 	 SET_C_OFF(C0000,0);
	 	 c_count[0]=0; 
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9036,9036);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_Y_ON(Y0025,25);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_Y_OFF(Y0025,25);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI 
	 flag = GET_T(T0001,1);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// TIM 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0004,4)) { 
	 	 	 SET_UTRG_ON(UTRG0004,4);
	 	 } else { 
	 	 	 if ((t_count[0] + (spantime) ) >=  1 * 100000){
	 	 	 	 t_count[0] = 1 * 100000; 
	 	 	 	 SET_T_ON(T0000,0);
	 	 	 } else {
	 	 	 	 t_count[0] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[0] = 0;
	 	 SET_T_OFF(T0000,0);
	 	 SET_UTRG_OFF(UTRG0004,4);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_T(T0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// TIM 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0005,5)) { 
	 	 	 SET_UTRG_ON(UTRG0005,5);
	 	 } else { 
	 	 	 if ((t_count[1] + (spantime) ) >=  1 * 100000){
	 	 	 	 t_count[1] = 1 * 100000; 
	 	 	 	 SET_T_ON(T0001,1);
	 	 	 } else {
	 	 	 	 t_count[1] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[1] = 0;
	 	 SET_T_OFF(T0001,1);
	 	 SET_UTRG_OFF(UTRG0005,5);
	 }
	 
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_Y_ON(Y0005,5);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_Y_OFF(Y0005,5);
	 }
	 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// CNT 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0006,6)) { 
	 	 	 if(!GET_C(C0000,0)) { 
	 	 	 if (c_count[0] <  9999 ) { 
	 	 	 	 c_count[0] ++; 
	 	 	 	 if (c_count[0] >= 9999) { 
	 	 	 	 	 SET_C_ON(C0000,0);
	 	 	 	 } 
	 	 	 } else { 
	 	 	 	 
	 	 	 }
	 	 	 }
	 	 	 SET_UTRG_ON(UTRG0006,6);
	 	 } else { 
	 	 } 
	 } else {
	 	 SET_UTRG_OFF(UTRG0006,6);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI 
	 flag = GET_T(T0000,0);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_Y_ON(Y0026,26);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_Y_OFF(Y0026,26);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ = D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 == 4);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0007, 7)) { 
	 	 D9002 = 2 ; 
	 	 	 SET_UTRG_ON(UTRG0007,7);
	 	 } 
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0007,7);
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// INC BCDデータのインクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0008, 8)) { 
	 	 	 int tmpB = bcdbin(D0000);
	 	 	 if(tmpB==9999){
 	 	 	 	 tmpB=0;
	 	 	 } else {
	 	 	 	 tmpB++; 
	 	 	 }
	 	 	 D0000 = binbcd(tmpB);
	 	 	 SET_UTRG_ON(UTRG0008,8);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0008,8);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ = D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 == 5);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0009, 9)) { 
	 	 D9002 = 1 ; 
	 	 	 SET_UTRG_ON(UTRG0009,9);
	 	 } 
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0009,9);
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// DEC　BCDデータのデクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0010, 10)) { 
	 	 	 int tmpB = bcdbin(D0000);
	 	 	 if(tmpB==0) {
	 	 	 	 tmpB=9999;
	 	 	 } else {
	 	 	 	 tmpB--; 
	 	 	 }
	 	 	 D0000 = binbcd(tmpB);
	 	 	 SET_UTRG_ON(UTRG0010,10);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0010,10);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND 
// -[ = D0 D1 ]- 
// 桁指定はまだ未対応です。
	 flag = (D9005 == 0);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0011, 11)) { 
	 	 D9002 = 0 ; 
	 	 	 SET_UTRG_ON(UTRG0011,11);
	 	 } 
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0011,11);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9036,9036);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// TIM 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0012,12)) { 
	 	 	 SET_UTRG_ON(UTRG0012,12);
	 	 } else { 
	 	 	 if ((t_count[2] + (spantime) ) >=  5 * 100000){
	 	 	 	 t_count[2] = 5 * 100000; 
	 	 	 	 SET_T_ON(T0002,2);
	 	 	 } else {
	 	 	 	 t_count[2] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[2] = 0;
	 	 SET_T_OFF(T0002,2);
	 	 SET_UTRG_OFF(UTRG0012,12);
	 }
	 
// CNT 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0013,13)) { 
	 	 	 if(!GET_C(C0001,1)) { 
	 	 	 if (c_count[1] <  1 ) { 
	 	 	 	 c_count[1] ++; 
	 	 	 	 if (c_count[1] >= 1) { 
	 	 	 	 	 SET_C_ON(C0001,1);
	 	 	 	 } 
	 	 	 } else { 
	 	 	 	 
	 	 	 }
	 	 	 }
	 	 	 SET_UTRG_ON(UTRG0013,13);
	 	 } else { 
	 	 } 
	 } else {
	 	 SET_UTRG_OFF(UTRG0013,13);
	 }
	 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// CNT 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0014,14)) { 
	 	 	 if(!GET_C(C0002,2)) { 
	 	 	 if (c_count[2] <  1 ) { 
	 	 	 	 c_count[2] ++; 
	 	 	 	 if (c_count[2] >= 1) { 
	 	 	 	 	 SET_C_ON(C0002,2);
	 	 	 	 } 
	 	 	 } else { 
	 	 	 	 
	 	 	 }
	 	 	 }
	 	 	 SET_UTRG_ON(UTRG0014,14);
	 	 } else { 
	 	 } 
	 } else {
	 	 SET_UTRG_OFF(UTRG0014,14);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_T(T0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// INCB Binaryデータのインクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0015, 15)) { 
	 	 	 D0001++; 
	 	 	 SET_UTRG_ON(UTRG0015,15);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0015,15);
	 } 
// MPP 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0002 = 0xFFF0 ; 
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// T0ISTA 
    if (aax & iix) { 
        if (htimer==NULL){
			timerStart();
        }
    } else {
			timerStop();
    }
	 output_refresh();	// 出力更新処理
//	 M5.update(); 
	// Serial.println();
	 SET_E_OFF(M9038,0);

 if (mySerial1.available()) {
    while(mySerial1.available()){
      int inByte = mySerial1.read();
			if ((stxFlag & 0x01) == 0) {  //  stx受信フラグがあるかどうかのチェック 0なし、1あり		
				if (inByte == 0x02) { //  １回目のＳＴＸ受信時		
					stxFlag = 1;    // STX受信フラグのセット		
					rvData[inposrc++] = (uint8_t)inByte;  // 受信データを格納		
				}		
				else {		
					inposrc = 0;		
					stxFlag = 0;		
				}		
			}		
			else {  // データサイズ受信フラグ判定		
				if ((stxFlag & 0x02) == 0) {  //  // データ長受信フラグがあるか判定 　0なし、2あり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					dataLength = (uint8_t)inByte & 0x7F;  // データサイズをセット		
					stxFlag |= 0x02;    // データ長受信フラグありに変更		
				}		
				else {  // データサイズ受信フラグあり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					if (dataLength < (inposrc - 4)) { // 受信データの位置が受信予定サイズより大きくなったら		
						inposrc = 0;            // 位置をクリアする		
						stxFlag = 0;            // 受信フラグをクリア		
					}		
					else if ((inposrc - 4) < dataLength) { // dataLengthより短い場合、データがそろっていない		
					}		
					else if (rvData[inposrc - 1] == 0x03) { // 終端文字ＥＴＸを受信したとき		
						int ressize;		
						ressize = AnalyzePacket(rvData, inposrc);		// 連枝からのモニタ要求に対する応答のデータ生成とデータ作成
						if (ressize>0) {		
							for (int sendcount = 0; sendcount < ressize; sendcount++) {		
								mySerial1.write(txData[sendcount]);		
							}		
						}		
						inposrc = 0;  // 位置をクリアする		
						stxFlag = 0;  //受信フラグをクリア		
					}		
					else {		
						// 受信予定サイズだけど、ETXじゃない場合   		
					}		
				}		
			}		
		}		
	}		


	  vTaskDelay(1);  // タスクの切り替えのために呼び出し(1ms待ち) 
	
}
////////////////////////////// Loop 終了 //////////////////////////////
